#!/bin/sh

. $(dirname $0)/INSTALLCONFIG.FILE

BUILD_DIR=$1
BUILD_SIM=$2
echo "In INSTALL SCRIPT"
# install files into LIB_DIR
$MKDIR $RPM_ROOT$LIB_DIR
$COPY ${LIB_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$LIB_DIR

# install files into CIM_LIB_DIR
$MKDIR $RPM_ROOT$CIM_LIB_DIR
$COPY ${CIM_LIB_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$CIM_LIB_DIR
	
# install files into INCLUDE_DIR
$MKDIR $RPM_ROOT$INCLUDE_DIR
$COPY ${INCLUDE_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$INCLUDE_DIR

# install files into BIN_DIR
$MKDIR $RPM_ROOT$BIN_DIR
$COPY ${BIN_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$BIN_DIR

#install files into UNIT_DIR
$MKDIR $RPM_ROOT$UNIT_DIR
$COPY $BUILD_DIR/$INIT_FILES $RPM_ROOT$UNIT_DIR
	
#install files into DATADIR
$MKDIR $RPM_ROOT$PRODUCT_DATADIR
$COPY ${DATADIR_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$PRODUCT_DATADIR
	
#install manpage files into MAN8_DIR
$MKDIR $RPM_ROOT$MAN8_DIR
$MOVE ${MANPAGE_GZ_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$MAN8_DIR
mandb
	
if [ $BUILD_SIM -eq 1 ]
then
	LD_LIBRARY_PATH=$BUILD_DIR
	$(export LD_LIBRARY_PATH); $BUILD_DIR/create_simulator --path $RPM_ROOT$PRODUCT_DATADIR
	$MOVE $RPM_ROOT$PRODUCT_DATADIR/apss.dat.smoke $RPM_ROOT$PRODUCT_DATADIR/apss.dat
fi

#install Pegasus Files
$MKDIR $RPM_ROOT$PEGASUS_MOFDIR
$COPY ${PEGASUS_MOF_FILES[@]/#/$BUILD_DIR/} $RPM_ROOT$PEGASUS_MOFDIR
	
#install SFCB Files
$MKDIR $RPM_ROOT$SFCB_DIR
$COPY $BUILD_DIR/$SFCB_MOF_FILES $RPM_ROOT$SFCB_DIR
$COPY $BUILD_DIR/$SFCB_REG_FILE $RPM_ROOT$SFCB_DIR
	
$MKDIR $RPM_ROOT$SYSCONF_DIR/ld.so.conf.d
echo $CIM_LIB_DIR > $RPM_ROOT$SYSCONF_DIR/ld.so.conf.d/$LINUX_PRODUCT_NAME-$HW_ARCH.conf
/sbin/ldconfig
